#include "EpsControl.h"
#include <qlabel.h>
#include <qpushbutton.h>
#include <qlayout.h>
#include <math.h>
#include <stdlib.h>
#include "ReSCutils.h"

EpsControl::EpsControl( const char* txt, const double& _val, const double& _min, const double& _max, const double& _step, QWidget *parent, const char *name )
        : QWidget( parent, name )
{

    val = _val;
    min = _min;
    max = _max;
    step = _step;

    text = new char[strlen(txt)];
    strcpy(text,txt);
    
    char* dtext = new char[strlen(txt)+10];
    strcpy(dtext,text);
    char numtxt[10];
    dtoa(val,&numtxt[0],1);
    strcat(dtext,&(numtxt[0]));
    value = new QLabel(dtext,this);
    delete[] dtext;

    QPushButton *increase = new QPushButton( "+", this, "inc" );
    increase->setAutoRepeat(TRUE);
    QPushButton *decrease = new QPushButton( "-", this, "dec" );
    decrease->setAutoRepeat(TRUE);
    increase->setFont( QFont( "Arial", 8, QFont::Normal ) );
    decrease->setFont( QFont( "Arial", 8, QFont::Normal ) );

    connect( increase, SIGNAL(clicked()), this, SLOT(inc()) );
    connect( decrease, SIGNAL(clicked()), this, SLOT(dec()) );

    QGridLayout *grid = new QGridLayout( this, 1, 3, 10 );

    grid->addWidget( value, 0, 0 );
    grid->addWidget( increase, 0, 1);
    grid->addWidget( decrease, 0, 2 );

    grid->setColStretch( 0, 10 );

}

void EpsControl::inc()
{
    val += step;
    char* dtext = new char[strlen(text)+10];
    strcpy(dtext,text);
    char numtxt[10];
    dtoa(val,&numtxt[0],1);
    strcat(dtext,&(numtxt[0]));
    value->setText(dtext);
    delete[] dtext;
    emit valueChanged(val);
}

void EpsControl::dec()
{
    if (val<=step)
        return;
    val -= step;
    char* dtext = new char[strlen(text)+10];
    strcpy(dtext,text);
    char numtxt[10];
    dtoa(val,&numtxt[0],1);
    strcat(dtext,&(numtxt[0]));
    value->setText(dtext);
    delete[] dtext;
    emit valueChanged(val);
}

EpsControl::~EpsControl()
{
}