#ifndef RESCUE__COMPACT_INTERVAL_BORDER_H
#define RESCUE__COMPACT_INTERVAL_BORDER_H

#include "rescutil.h"
// ==========================================================================================
// ==========================================================================================

namespace rescue
{


template<class border_value_t, class index_t>
class compact_interval_border
{

public:

    typedef border_value_t border_value;

//private:

    border_value m_value;
    border_type m_type;

    index_t m_col;
    index_t m_row;
    graph_direction m_dir;
   
public:

    // ==========================================================================================
    inline compact_interval_border(const border_value& value, const border_type& type, const index_t& col,
        const index_t& row, const graph_direction& dir)
    // ==========================================================================================
    {
        m_value = value;
        m_type = type;

        m_col = col;
        m_row = row;
        m_dir = dir;
    }

    // ==========================================================================================
    compact_interval_border()
    // ==========================================================================================
    {
    }

    // ==========================================================================================
    inline bool operator<(const compact_interval_border& cib) const
    // ==========================================================================================
    {
        if (this->m_value < cib.m_value)
            return true;
        if (cib.m_value < this->m_value)
            return false;
        if (this->m_type < cib.m_type)
            return true;
        if (cib.m_type < this->m_type)
            return false;
        return false;
    }

    inline border_value val() const
    {
        return m_value;
    }

    inline index_t col() const
    {
        return m_col;
    }

    inline index_t row() const
    {
        return m_row;
    }

    inline graph_direction dir() const
    {
        return m_dir;
    }

    inline border_type type() const
    {
        return m_type;
    }

};

// ==========================================================================================
// ==========================================================================================

}


#endif


