#ifndef POLYGONVERTEX_H
#define POLYGONVERTEX_H

#include "Point2.h"

namespace rescue
{

// ==========================================================================================
// ==========================================================================================

template <class point>
class polygon_vertex
{

public:
    
    typedef point point_t;
    typedef point_t::arithmetic_t arithmetic_t;
    typedef arithmetic_t arithmetic;

    point pos;
    polygon_vertex<point>* next;
    polygon_vertex<point>* prev;

    polygon_vertex();
    polygon_vertex(const point&);
    polygon_vertex(const point&, polygon_vertex<point>&);
    polygon_vertex(const point&, const polygon_vertex<point>&, const polygon_vertex<point>&);

};

// ==========================================================================================
// ==========================================================================================



// ==========================================================================================
template <class point>
polygon_vertex<point>::polygon_vertex()
// ==========================================================================================
{
}

// ==========================================================================================
template <class point>
polygon_vertex<point>::polygon_vertex(
    const point& p)
// ==========================================================================================
{
    pos = p;
}

// ==========================================================================================
template <class point>
polygon_vertex<point>::polygon_vertex(
    const point& p, 
    polygon_vertex<point>& nx)
// ==========================================================================================
{
    pos = p;
    next = &nx;
    if (next != NULL)
        next->prev = this;
    prev = NULL;
}

// ==========================================================================================
template <class point>
polygon_vertex<point>::polygon_vertex(
    const point& p, 
    const polygon_vertex<point>& nx,
    const polygon_vertex<point>& pr)
// ==========================================================================================
{
    pos = p;
    next = &nx;
    prev = &pr;
    if (next != NULL)
        next->prev = this;
    if (prev != NULL)
        prev->next = this;
}



}

#endif
