/** 
\mainpage
\section ReSCue - REtrieval System for CUrvEs

Test-Applikation zur hnlichkeitssuche nach Kurven im 2D 
bezglich Frechet-Distanz.

*/

#pragma warning( disable : 4786 )        

//#define RESCUE_VERBOSE
//#include "covering_matcher.h"
//#include "s1_interval_container.h"
#include "sampling_matcher.h"
#include "circular_arc_edge.h"
#include "free_space_graph.h"
//#include "extended_fs_graph.h"
#include <iostream>
//#include <LEDA/real.h>

using namespace rescue;

#define MAX_HITS 10

typedef Point2<double> Point;
#ifdef COVERING_MATCHER 
typedef covering_matcher<double,s1_interval_container<double,int> > FrechetMatcher;
#else
typedef sampling_matcher<
            free_space_graph<
                circular_arc_edge<int,Point> 
            > 
        > 
        FrechetMatcher;
#endif 

typedef FrechetMatcher::curve Curve;
typedef FrechetMatcher::vertex Vertex;


int main(int argc, char** args)
{

    std::cout<<"Welcome to Rescue, the Retrieval System for Curves.\n\n";


    Curve P;
    Curve Q;

    Point p(3.0,3.0);
    Vertex v1(p);
    P.push_front((Vertex*)(&v1));

    p = Point(2.0,2.0);
    Vertex v2(p);
    P.push_front((Vertex*)(&v2));

    p = Point(1.0,1.0);
    Vertex v3(p);
    P.push_front((Vertex*)(&v3));

    p = Point(2.7,3.0);
    Vertex v4(p);
    Q.push_front((Vertex*)(&v4));

    p = Point(1.3,1.0);
    Vertex v5(p);
    Q.push_front((Vertex*)(&v5));

    FrechetMatcher M(P,Q,0.1,0.1);

    bool matches = M.match();

    if (matches==true)
        std::cout<<"Match!\n";
    else
        std::cout<<"No Match!\n";

    return 0;

}


